diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/bindings/modulegen__gcc_LP64.py ns-3.36/src/antenna/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/antenna/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:57.738733000 -0700
@@ -88,17 +88,17 @@
     typehandlers.add_type_alias('std::vector< std::complex< double > >', 'ns3::PhasedArrayModel::ComplexVector')
     typehandlers.add_type_alias('std::vector< std::complex< double > >*', 'ns3::PhasedArrayModel::ComplexVector*')
     typehandlers.add_type_alias('std::vector< std::complex< double > >&', 'ns3::PhasedArrayModel::ComplexVector&')
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> > [class]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor>> [class]
     module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), parent=root_module['ns3::empty'], template_parameters=['ns3::AttributeAccessor', 'ns3::empty', 'ns3::DefaultDeleter<ns3::AttributeAccessor>'])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> > [class]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker>> [class]
     module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), parent=root_module['ns3::empty'], template_parameters=['ns3::AttributeChecker', 'ns3::empty', 'ns3::DefaultDeleter<ns3::AttributeChecker>'])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> > [class]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue>> [class]
     module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), parent=root_module['ns3::empty'], template_parameters=['ns3::AttributeValue', 'ns3::empty', 'ns3::DefaultDeleter<ns3::AttributeValue>'])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> > [class]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase>> [class]
     module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), parent=root_module['ns3::empty'], template_parameters=['ns3::CallbackImplBase', 'ns3::empty', 'ns3::DefaultDeleter<ns3::CallbackImplBase>'])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> > [class]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation>> [class]
     module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), parent=root_module['ns3::empty'], template_parameters=['ns3::Hash::Implementation', 'ns3::empty', 'ns3::DefaultDeleter<ns3::Hash::Implementation>'])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> > [class]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor>> [class]
     module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), parent=root_module['ns3::empty'], template_parameters=['ns3::TraceSourceAccessor', 'ns3::empty', 'ns3::DefaultDeleter<ns3::TraceSourceAccessor>'])
     ## trace-source-accessor.h (module 'core'): ns3::TraceSourceAccessor [class]
     module.add_class('TraceSourceAccessor', import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> >'])
@@ -147,7 +147,7 @@
     ## callback.h (module 'core'): ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> [class]
     module.add_class('CallbackImpl', import_from_module='ns.core', parent=root_module['ns3::CallbackImplBase'], template_parameters=['ns3::ObjectBase *', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'])
     module.add_container('std::vector< double >', 'double', container_type='vector')
-    module.add_container('std::map< std::string, ns3::LogComponent * >', ('std::string', 'ns3::LogComponent *'), container_type='map')
+    module.add_container('std::map< std::string, ns3::LogComponent * >', ('std::basic_string< char, std::char_traits< char >, std::allocator< char > >', 'ns3::LogComponent *'), container_type='map')
     module.add_container('std::vector< std::complex< double > >', 'std::complex< double >', container_type='vector')
     module.add_container('ns3::PhasedArrayModel::ComplexVector', 'std::complex< double >', container_type='vector')
     typehandlers.add_type_alias('ns3::Vector3D', 'ns3::Vector')
@@ -605,8 +605,8 @@
     cls.add_binary_comparison_operator('!=')
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('<')
-    ## type-id.h (module 'core'): ns3::TypeId::TypeId(char const * name) [constructor]
-    cls.add_constructor([param('char const *', 'name')])
+    ## type-id.h (module 'core'): ns3::TypeId::TypeId(std::string const & name) [constructor]
+    cls.add_constructor([param('std::string const &', 'name')])
     ## type-id.h (module 'core'): ns3::TypeId::TypeId() [constructor]
     cls.add_constructor([])
     ## type-id.h (module 'core'): ns3::TypeId::TypeId(ns3::TypeId const & o) [constructor]
@@ -996,6 +996,11 @@
                    'ns3::Vector', 
                    [param('uint64_t', 'index')], 
                    is_const=True, is_pure_virtual=True, is_virtual=True)
+    ## phased-array-model.h (module 'antenna'): uint32_t ns3::PhasedArrayModel::GetId() const [member function]
+    cls.add_method('GetId', 
+                   'uint32_t', 
+                   [], 
+                   is_const=True)
     ## phased-array-model.h (module 'antenna'): uint64_t ns3::PhasedArrayModel::GetNumberOfElements() const [member function]
     cls.add_method('GetNumberOfElements', 
                    'uint64_t', 
@@ -1027,44 +1032,44 @@
     return
 
 def register_Ns3SimpleRefCount__Ns3AttributeAccessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeAccessor__gt___methods(root_module, cls):
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> >::SimpleRefCount() [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor>>::SimpleRefCount() [constructor]
     cls.add_constructor([])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> >::SimpleRefCount(ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor> > const & o) [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor>>::SimpleRefCount(ns3::SimpleRefCount<ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter<ns3::AttributeAccessor>> const & o) [constructor]
     cls.add_constructor([param('ns3::SimpleRefCount< ns3::AttributeAccessor, ns3::empty, ns3::DefaultDeleter< ns3::AttributeAccessor > > const &', 'o')])
     return
 
 def register_Ns3SimpleRefCount__Ns3AttributeChecker_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeChecker__gt___methods(root_module, cls):
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> >::SimpleRefCount() [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker>>::SimpleRefCount() [constructor]
     cls.add_constructor([])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> >::SimpleRefCount(ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker> > const & o) [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker>>::SimpleRefCount(ns3::SimpleRefCount<ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter<ns3::AttributeChecker>> const & o) [constructor]
     cls.add_constructor([param('ns3::SimpleRefCount< ns3::AttributeChecker, ns3::empty, ns3::DefaultDeleter< ns3::AttributeChecker > > const &', 'o')])
     return
 
 def register_Ns3SimpleRefCount__Ns3AttributeValue_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeValue__gt___methods(root_module, cls):
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> >::SimpleRefCount() [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue>>::SimpleRefCount() [constructor]
     cls.add_constructor([])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> >::SimpleRefCount(ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue> > const & o) [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue>>::SimpleRefCount(ns3::SimpleRefCount<ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter<ns3::AttributeValue>> const & o) [constructor]
     cls.add_constructor([param('ns3::SimpleRefCount< ns3::AttributeValue, ns3::empty, ns3::DefaultDeleter< ns3::AttributeValue > > const &', 'o')])
     return
 
 def register_Ns3SimpleRefCount__Ns3CallbackImplBase_Ns3Empty_Ns3DefaultDeleter__lt__ns3CallbackImplBase__gt___methods(root_module, cls):
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> >::SimpleRefCount() [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase>>::SimpleRefCount() [constructor]
     cls.add_constructor([])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> >::SimpleRefCount(ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase> > const & o) [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase>>::SimpleRefCount(ns3::SimpleRefCount<ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter<ns3::CallbackImplBase>> const & o) [constructor]
     cls.add_constructor([param('ns3::SimpleRefCount< ns3::CallbackImplBase, ns3::empty, ns3::DefaultDeleter< ns3::CallbackImplBase > > const &', 'o')])
     return
 
 def register_Ns3SimpleRefCount__Ns3HashImplementation_Ns3Empty_Ns3DefaultDeleter__lt__ns3HashImplementation__gt___methods(root_module, cls):
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> >::SimpleRefCount() [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation>>::SimpleRefCount() [constructor]
     cls.add_constructor([])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> >::SimpleRefCount(ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation> > const & o) [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation>>::SimpleRefCount(ns3::SimpleRefCount<ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter<ns3::Hash::Implementation>> const & o) [constructor]
     cls.add_constructor([param('ns3::SimpleRefCount< ns3::Hash::Implementation, ns3::empty, ns3::DefaultDeleter< ns3::Hash::Implementation > > const &', 'o')])
     return
 
 def register_Ns3SimpleRefCount__Ns3TraceSourceAccessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3TraceSourceAccessor__gt___methods(root_module, cls):
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> >::SimpleRefCount() [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor>>::SimpleRefCount() [constructor]
     cls.add_constructor([])
-    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> >::SimpleRefCount(ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor> > const & o) [constructor]
+    ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor>>::SimpleRefCount(ns3::SimpleRefCount<ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter<ns3::TraceSourceAccessor>> const & o) [constructor]
     cls.add_constructor([param('ns3::SimpleRefCount< ns3::TraceSourceAccessor, ns3::empty, ns3::DefaultDeleter< ns3::TraceSourceAccessor > > const &', 'o')])
     return
 
@@ -1753,7 +1758,7 @@
 
 def register_functions(root_module):
     module = root_module
-    ## angles.h (module 'antenna'): std::vector<double, std::allocator<double> > ns3::DegreesToRadians(std::vector<double, std::allocator<double> > const & degrees) [free function]
+    ## angles.h (module 'antenna'): std::vector<double, std::allocator<double>> ns3::DegreesToRadians(std::vector<double, std::allocator<double>> const & degrees) [free function]
     module.add_function('DegreesToRadians', 
                         'std::vector< double >', 
                         [param('std::vector< double > const &', 'degrees')])
@@ -1761,7 +1766,7 @@
     module.add_function('DegreesToRadians', 
                         'double', 
                         [param('double', 'degrees')])
-    ## angles.h (module 'antenna'): std::vector<double, std::allocator<double> > ns3::RadiansToDegrees(std::vector<double, std::allocator<double> > const & radians) [free function]
+    ## angles.h (module 'antenna'): std::vector<double, std::allocator<double>> ns3::RadiansToDegrees(std::vector<double, std::allocator<double>> const & radians) [free function]
     module.add_function('RadiansToDegrees', 
                         'std::vector< double >', 
                         [param('std::vector< double > const &', 'radians')])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/CMakeLists.txt ns-3.36/src/antenna/CMakeLists.txt
--- ns-3.35/src/antenna/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/antenna/CMakeLists.txt	2022-04-30 18:23:57.726733000 -0700
@@ -0,0 +1,29 @@
+build_lib(
+  LIBNAME antenna
+  SOURCE_FILES
+    model/angles.cc
+    model/antenna-model.cc
+    model/cosine-antenna-model.cc
+    model/isotropic-antenna-model.cc
+    model/parabolic-antenna-model.cc
+    model/phased-array-model.cc
+    model/three-gpp-antenna-model.cc
+    model/uniform-planar-array.cc
+  HEADER_FILES
+    model/angles.h
+    model/antenna-model.h
+    model/cosine-antenna-model.h
+    model/isotropic-antenna-model.h
+    model/parabolic-antenna-model.h
+    model/phased-array-model.h
+    model/three-gpp-antenna-model.h
+    model/uniform-planar-array.h
+  LIBRARIES_TO_LINK ${libcore}
+  TEST_SOURCES
+    test/test-angles.cc
+    test/test-degrees-radians.cc
+    test/test-isotropic-antenna.cc
+    test/test-cosine-antenna.cc
+    test/test-parabolic-antenna.cc
+    test/test-uniform-planar-array.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/doc/source/conf.py ns-3.36/src/antenna/doc/source/conf.py
--- ns-3.35/src/antenna/doc/source/conf.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/doc/source/conf.py	2022-04-30 18:23:57.738733000 -0700
@@ -25,7 +25,7 @@
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.pngmath']
+extensions = ['sphinx.ext.imgmath']
 
 # Add any paths that contain templates here, relative to this directory.
 templates_path = ['_templates']
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/model/angles.cc ns-3.36/src/antenna/model/angles.cc
--- ns-3.35/src/antenna/model/angles.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/model/angles.cc	2022-04-30 18:23:57.738733000 -0700
@@ -30,7 +30,9 @@
 
 bool Angles::m_printDeg = false;
 
+/// Degrees to Radians conversion constant
 const double DEG_TO_RAD = M_PI / 180.0;
+/// Radians to Degrees conversion constant
 const double RAD_TO_DEG = 180.0 / M_PI;
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/model/angles.h ns-3.36/src/antenna/model/angles.h
--- ns-3.35/src/antenna/model/angles.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/model/angles.h	2022-04-30 18:23:57.738733000 -0700
@@ -178,7 +178,21 @@
   double GetInclination (void) const;
 
   // friend methods
+  /**
+   * \brief Stream insertion operator.
+   *
+   * \param [in] os The reference to the output stream.
+   * \param [in] a The angle.
+   * \returns The reference to the output stream.
+   */
   friend std::ostream& operator<< (std::ostream& os, const Angles& a);
+  /**
+   * \brief Stream extraction operator.
+   *
+   * \param [in] is The reference to the input stream.
+   * \param [out] a The angle.
+   * \returns The reference to the input stream.
+   */
   friend std::istream& operator>> (std::istream& is, Angles& a);
 
   static bool m_printDeg; //!< flag for printing in radians or degrees units
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/model/antenna-model.h ns-3.36/src/antenna/model/antenna-model.h
--- ns-3.35/src/antenna/model/antenna-model.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/model/antenna-model.h	2022-04-30 18:23:57.738733000 -0700
@@ -27,6 +27,19 @@
 
 namespace ns3 {
 
+
+/**
+ * \defgroup antenna Antenna module
+ * \brief This module contains several antenna
+ * radiation pattern models.
+ */
+
+/**
+ * \ingroup antenna
+ * \ingroup tests
+ * \defgroup antenna-tests Antenna module tests
+ */
+
 /** 
  * \ingroup antenna
  * 
@@ -38,8 +51,6 @@
  * angles. This choice is the one proposed "Antenna Theory - Analysis
  * and Design", C.A. Balanis, Wiley, 2nd Ed., see in particular
  * section 2.2 "Radiation pattern".
- * 
- *
  */
 class AntennaModel : public Object
 {
@@ -49,7 +60,10 @@
   AntennaModel ();
   virtual ~AntennaModel ();
 
-  // inherited from Object
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
   static TypeId GetTypeId ();
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/model/cosine-antenna-model.h ns-3.36/src/antenna/model/cosine-antenna-model.h
--- ns-3.35/src/antenna/model/cosine-antenna-model.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/model/cosine-antenna-model.h	2022-04-30 18:23:57.742733000 -0700
@@ -28,6 +28,7 @@
 namespace ns3 {
 
 /**
+ * \ingroup antenna
  *
  * \brief Cosine Antenna Model
  *
@@ -49,7 +50,10 @@
 class CosineAntennaModel : public AntennaModel
 {
 public:
-  // inherited from Object
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
   static TypeId GetTypeId ();
 
   // inherited from AntennaModel
@@ -95,7 +99,7 @@
 
   /**
    * Compute the exponent of the cosine antenna model from the beamwidth
-   * \param beamwidthRadians the beamwidth in degrees
+   * \param beamwidthDegrees the beamwidth in degrees
    * \return the exponent
    */
   static double GetExponentFromBeamwidth (double beamwidthDegrees);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/model/isotropic-antenna-model.h ns-3.36/src/antenna/model/isotropic-antenna-model.h
--- ns-3.35/src/antenna/model/isotropic-antenna-model.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/model/isotropic-antenna-model.h	2022-04-30 18:23:57.742733000 -0700
@@ -28,6 +28,8 @@
 namespace ns3 {
 
 /**
+ * \ingroup antenna
+ * 
  * \brief Isotropic antenna model
  * 
  * This is the simplest antenna model. The gain of this antenna is the same in all directions.
@@ -37,7 +39,11 @@
 public:
 
   IsotropicAntennaModel ();
-  // inherited from Object
+  
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
   static TypeId GetTypeId ();
 
   // inherited from AntennaModel
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/model/parabolic-antenna-model.h ns-3.36/src/antenna/model/parabolic-antenna-model.h
--- ns-3.35/src/antenna/model/parabolic-antenna-model.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/model/parabolic-antenna-model.h	2022-04-30 18:23:57.742733000 -0700
@@ -28,12 +28,13 @@
 namespace ns3 {
 
 /**
+ * \ingroup antenna
  * 
  * \brief  Antenna model based on a parabolic approximation of the main lobe radiation pattern.
  *
  * This class implements the parabolic model as described in some 3GPP document, e.g., R4-092042
  *
- * A similar model appears in 
+ * A similar model appears in:
  *
  * George Calcev and Matt Dillon, "Antenna Tilt Control in CDMA Networks"
  * in Proc. of the 2nd Annual International Wireless Internet Conference (WICON), 2006
@@ -46,7 +47,10 @@
 {
 public:
 
-  // inherited from Object
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
   static TypeId GetTypeId ();
 
   // inherited from AntennaModel
@@ -54,18 +58,32 @@
 
 
   // attribute getters/setters
+  /**
+   * Set the Beam width
+   * \param beamwidthDegrees Beam width in degrees
+   */
   void SetBeamwidth (double beamwidthDegrees);
+  /**
+   * Get the Beam width
+   * \return beam width in degrees
+   */
   double GetBeamwidth () const;
+  /**
+   * Set the antenna orientation
+   * \param orientationDegrees antenna orientation in degrees
+   */
   void SetOrientation (double orientationDegrees);
+  /**
+   * Get the antenna orientation
+   * \return antenna orientation in degrees
+   */
   double GetOrientation () const;
 
 private:
 
-  double m_beamwidthRadians;
-
-  double m_orientationRadians;
-
-  double m_maxAttenuation;
+  double m_beamwidthRadians; //!< Beam width in radians
+  double m_orientationRadians; //!< Antenna orientation in radians
+  double m_maxAttenuation; //!< Max attenuation
 };
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/model/phased-array-model.cc ns-3.36/src/antenna/model/phased-array-model.cc
--- ns-3.35/src/antenna/model/phased-array-model.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/model/phased-array-model.cc	2022-04-30 18:23:57.742733000 -0700
@@ -26,6 +26,8 @@
 
 namespace ns3 {
 
+uint32_t PhasedArrayModel::m_idCounter = 0 ;
+
 NS_LOG_COMPONENT_DEFINE ("PhasedArrayModel");
 
 NS_OBJECT_ENSURE_REGISTERED (PhasedArrayModel);
@@ -54,7 +56,9 @@
 
 PhasedArrayModel::PhasedArrayModel ()
   : m_isBfVectorValid {false}
-{}
+{
+  m_id = m_idCounter++;
+}
 
 
 PhasedArrayModel::~PhasedArrayModel ()
@@ -164,6 +168,11 @@
   return m_antennaElement;
 }
 
+uint32_t
+PhasedArrayModel::GetId () const
+{
+  return m_id;
+}
 
 } /* namespace ns3 */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/model/phased-array-model.h ns-3.36/src/antenna/model/phased-array-model.h
--- ns-3.35/src/antenna/model/phased-array-model.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/model/phased-array-model.h	2022-04-30 18:23:57.742733000 -0700
@@ -47,7 +47,10 @@
   virtual ~PhasedArrayModel (void);
 
 
-  // inherited from Object
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
   static TypeId GetTypeId (void);
 
 
@@ -67,7 +70,7 @@
   /**
    * Returns the location of the antenna element with the specified
    * index, normalized with respect to the wavelength.
-   * \param idx index of the antenna element
+   * \param index the index of the antenna element
    * \return the 3D vector that represents the position of the element
    */
   virtual Vector GetElementLocation (uint64_t index) const = 0;
@@ -123,6 +126,12 @@
    */
   Ptr<const AntennaModel> GetAntennaElement (void) const;
 
+  /**
+   * Returns the ID of this antenna array instance
+   * \return the ID value
+   */
+  uint32_t GetId () const;
+
 protected:
   /**
    * Utility method to compute the euclidean norm of a ComplexVector
@@ -134,10 +143,17 @@
   ComplexVector m_beamformingVector; //!< the beamforming vector in use
   Ptr<AntennaModel> m_antennaElement; //!< the model of the antenna element in use
   bool m_isBfVectorValid; //!< ensures the validity of the beamforming vector
-
+  static uint32_t m_idCounter; //!< the ID counter that is used to determine the unique antenna array ID
+  uint32_t m_id {0}; //!< the ID of this antenna array instance
 };
 
-
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param [in] os The reference to the output stream.
+ * \param [in] cv A vector of complex values.
+ * \returns The reference to the output stream.
+ */
 std::ostream& operator<< (std::ostream& os, const PhasedArrayModel::ComplexVector& cv);
 
 } /* namespace ns3 */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/model/three-gpp-antenna-model.h ns-3.36/src/antenna/model/three-gpp-antenna-model.h
--- ns-3.35/src/antenna/model/three-gpp-antenna-model.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/model/three-gpp-antenna-model.h	2022-04-30 18:23:57.742733000 -0700
@@ -38,7 +38,10 @@
   ThreeGppAntennaModel (void);
   virtual ~ThreeGppAntennaModel (void) override;
 
-  // inherited from Object
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
   static TypeId GetTypeId ();
 
   // inherited from AntennaModel
@@ -75,8 +78,8 @@
   double GetAntennaElementGain () const;
 
 private:
-  double m_verticalBeamwidthDegrees;    //!< beamwidth in the vertical direction (\theta_{3dB}) [deg]
-  double m_horizontalBeamwidthDegrees;  //!< beamwidth in the horizontal direction (\phi_{3dB}) [deg]
+  double m_verticalBeamwidthDegrees;    //!< beamwidth in the vertical direction \f$(\theta_{3dB})\f$ [deg]
+  double m_horizontalBeamwidthDegrees;  //!< beamwidth in the horizontal direction \f$(\phi_{3dB})\f$ [deg]
   double m_aMax;                        //!< maximum attenuation (A_{max}) [dB]
   double m_slaV;                        //!< side-lobe attenuation in the vertical direction (SLA_V) [dB]
   double m_geMax;                       //!< maximum directional gain of the antenna element (G_{E,max}) [dBi]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/antenna/test/test-angles.cc ns-3.36/src/antenna/test/test-angles.cc
--- ns-3.35/src/antenna/test/test-angles.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/antenna/test/test-angles.cc	2022-04-30 18:23:57.742733000 -0700
@@ -28,17 +28,32 @@
 
 using namespace ns3;
 
+/**
+ * \ingroup tests
+ *
+ * \brief Angles Test using one vector for initialization
+ */
 class OneVectorConstructorTestCase : public TestCase
 {
 public:
+  /**
+   * Build the test name
+   * \param v test parameter
+   * \return the test name
+   */
   static std::string BuildNameString (Vector v);
+  /**
+   * Constructor
+   * \param v vector
+   * \param a expected angle
+   */
   OneVectorConstructorTestCase (Vector v, Angles a);
 
 private:
   virtual void DoRun (void);
 
-  Vector m_v;
-  Angles m_a;
+  Vector m_v; //!< vector
+  Angles m_a; //!< expected angle
 };
 
 std::string OneVectorConstructorTestCase::BuildNameString (Vector v)
@@ -65,20 +80,35 @@
 
 
 
-
-
+/**
+ * \ingroup tests
+ *
+ * \brief Angles Test using two vectors for initialization
+ */
 class TwoVectorsConstructorTestCase : public TestCase
 {
 public:
+  /**
+   * Build the test name
+   * \param v test parameter
+   * \param o test parameter
+   * \return the test name
+   */
   static std::string BuildNameString (Vector v, Vector o);
+  /**
+   * Constructor
+   * \param v point
+   * \param o origin
+   * \param a expected angle
+   */
   TwoVectorsConstructorTestCase (Vector v, Vector o, Angles a);
 
 private:
   virtual void DoRun (void);
 
-  Vector m_v;
-  Vector m_o;
-  Angles m_a;
+  Vector m_v; //!< point
+  Vector m_o; //!< origin
+  Angles m_a; //!< expected angle
 };
 
 std::string TwoVectorsConstructorTestCase::BuildNameString (Vector v, Vector o)
@@ -106,9 +136,11 @@
 
 
 
-
-
-
+/**
+ * \ingroup tests
+ *
+ * \brief Angles TestSuite
+ */
 class AnglesTestSuite : public TestSuite
 {
 public:
@@ -206,4 +238,5 @@
 
 }
 
-static AnglesTestSuite staticAnglesTestSuiteInstance;
+/// Static variable for test initialization
+static AnglesTestSuite g_staticAnglesTestSuiteInstance;
